#!/usr/bin/perl

use POSIX ":sys_wait_h";

# Change this path to reflect the location of virusscan.pm
require "/var/CommuniGate/virusscan.pm";

$|=1;

# Version String for this Filter
our $VERSION = "1.1r2";

# $bounces defines if CGPro shall bounce emails containing viruses
# if set to 1 (one) it will bounce, if set to 0 (zero) it will silently discard them
# but still notify the original recipient! Default is 0 - NO Bounces since most FROM
# addresses are faxed anyway
$bounces=0;

# Print Debugging Info to CGP? Default = 0 which is off
$debug=0;

# The location of the CommuniGate Pro base directory
$cgatedir="/var/CommuniGate/";

# The location of the Virex vscanx command-line utility
$vscan="/usr/local/vscanx/vscanx --unzip --mime";

# The error file to send to the user who emailed the virus
$errorfile="/var/CommuniGate/errormsg.txt";

# The error file send to the recipients of the virus
$notify="/var/CommuniGate/notify.txt";

# The log file that will hold a log of everything that has happened.
$logfile="/var/log/virus.log";

# A directory which will contain copies of all the viruses found on the system.
$virusdir="/var/log/virii";

# $notifyfrom sets the FROM Address for notification emails
$notifyfrom = "postmaster\@localhost";
# $notifybcc sets an addess to bcc notifications to
$notifybcc = "postmaster\@localhost";

# #######################################
# No user configurable stuff below here
# #######################################

$efcontents=`cat $errorfile`;
$ncontents=`cat $notify`;

my $request = <STDIN>;
our $one; # global, so it can be printed in debug lines
my %pids, my $pid;

print "* CGVirusscan $VERSION Ready\n";

while ($request) {
	# Give child processes a chance to be cleaned up...

  	foreach $pid (keys %pids)
	{
		if (waitpid($pid, &WNOHANG) == -1)
		{
			# child $pid has terminated
			delete $pids{$pid};
		}
	}
	
    if ($request =~ /([0-9]+)\s*([A-Za-z]+)\s*(.*)/si) {
		$one=$1; $two=$2; $three=$3;
		if ($two =~ /INTF/i) 
    	{
      		# CGPro wants to know our interface version (it's 2). We don't
      		# really care what CGPro's interface version is, since all we
      		# do is DISCARD or OK messages.
      		print "$one INTF 2\n";
    	}
    	elsif ($two =~ /FILE/i)
    	{ 
			$pid = 0;
			$pid = fork();
			
			if ($pid==0) 
			{
				if ( $debug=1 ) { print "* Starting scan for: $three"; } 
				&scanfile($one,$three);
				exit(); 
			}
			else
			{
				$pids{$pid} = 1;
			}
		}
		elsif ($two =~ /QUIT/i)
    	{
    		print "* QUIT Received: virusscan quitting."; 
			exit;
		}
    }
    $request = <STDIN>;
}
exit();


